package com.omi.db;
import java.util.GregorianCalendar;
import com.omi.util.*;

/**
 *  @author MAJIMA ATSUSHI@OMI-SYS
 *  @name   OMISearchSQL  
 *  @description cotains SQL expressions in this system  
 */
public class OMISearchSQL{
   /**
    *  SQL for Locations
    */
   public static String getSearchLocation(String scode_value , String sname){

      StringBuffer reqmsg = new StringBuffer("");
      if ( scode_value == null )
         scode_value = "" ;
      if( sname == null )
         sname = "";

       reqmsg.append("select id , name from Location_Table ");
       reqmsg.append( " where code='" );
       reqmsg.append(  scode_value );
       reqmsg.append("' and name like '");
       reqmsg.append(sname);
       reqmsg.append("%' and flg='01' "); 
       return reqmsg.toString();
   }
   /**
    * get Classes 
    * @param scode
    * @param ssubject
    * @param sdayofweek
    * @param sname
    * @return SQL Request
    */
   public static String getSearchClass(String scode,String ssubject,String sdayofweek , String sname){
      StringBuffer reqmsg = new StringBuffer("");
      reqmsg.append("select CS.id, CS.name, AF.value , LT.name as location,");
      reqmsg.append(" CS.start_date ,");
      reqmsg.append(" CS.end_date ,CS.start_time , CS.end_time , ");
      reqmsg.append(" MB.name_0 ,MB.name_1, CS.mx_students, CS.description ");
      reqmsg.append(" from ClassRoom_Table CS ,Members_Table MB ,Location_Table LT ");
      reqmsg.append("  left join Affiliated_Table AF on  AF.code=CS.level  and AF.description='LEVEL' ");
      reqmsg.append(" where CS.location=LT.id  and CS.teacher=MB.id and CS.code='");
      reqmsg.append(scode  );
      reqmsg.append("' and CS.subject = '");
      reqmsg.append(ssubject);
      reqmsg.append("' and CS.dayofweek = '");
      reqmsg.append( sdayofweek );
      reqmsg.append("' and CS.flg='01' and MB.flg='01' and CS.name like '");
      reqmsg.append(sname);
      reqmsg.append("%'");
      return reqmsg.toString();
   } 
   /**
    * get Members
    * @param code
    * @param name_0
    * @param name_1
    * @return SQL Request
    */
   public static String getSearchMembers(String code,String name_0,String name_1){
      StringBuffer reqmsg = new StringBuffer("");
      reqmsg.append("select MB.id ,MB.name_0,MB.name_1,MB.name_2,MB.name_3,");
      reqmsg.append(" MB.email ,MB.phone, MB.addr_0,MB.addr_1,MB.addr_2 , ");
      reqmsg.append(" MB.zone_0  from Members_Table MB ");
      reqmsg.append(" where MB.code='");
      reqmsg.append(code);
      reqmsg.append("' and MB.name_0 like '");
      reqmsg.append(name_0);
      reqmsg.append("%' and MB.name_1 like '");
      reqmsg.append(name_1);
      reqmsg.append("%' and flg='01' ");
      return reqmsg.toString();
   }

   /**
    *  getSQL for Selecting BaseCodes in Affiliated_Table
    */
   public static String getSearchBaseCodes(){
      return "select id , value from Affiliated_Table where code='000' and description = 'BASE_CODE' and flg='01' order by id";
   }
  /**
   * SQL for Selecting all Codes of Description 'sdesc'
   * @param String sdesc ( ie. description of BASECODE )
   */
   public static String getSearchCodes(String sdesc){
      StringBuffer reqmsg = new StringBuffer("");
      reqmsg.append("select id , code , value from Affiliated_Table where ");
      reqmsg.append("description = '");
      reqmsg.append(sdesc);
      reqmsg.append("' and flg='01' order by code");
      return reqmsg.toString();
   }
   /**
    *  getSQL for Selecting Classes
    *  String teacher_id  ie.id of teacher
    *  order by dayofweek start_time
    */
   public static String getSearchAllClasses(String teacher_id){
      StringBuffer reqmsg = new StringBuffer("");
      reqmsg.append("select CS.id, RG.zone_1,CS.name,SB.value as subject,CS.dayofweek,");
      reqmsg.append("LT.value,CS.start_time , CS.end_time from ClassRoom_Table CS ");
      reqmsg.append("left join Affiliated_Table LT on (LT.code = CS.level and LT.description='LEVEL' and LT.flg='01') ");
      reqmsg.append("left join Affiliated_Table RG on (RG.code = CS.code and RG.description='CLASSROOM' and RG.flg='01')");
      reqmsg.append("left join Affiliated_Table SB on (SB.code = CS.subject and SB.description='SUBJECT' and SB.flg='01')");
      reqmsg.append("where CS.flg='01'");
      if(teacher_id!=null){
         reqmsg.append("and CS.teacher='");
         reqmsg.append(teacher_id);
         reqmsg.append("'");
      }
      reqmsg.append(" order by dayofweek,start_time");
      return reqmsg.toString();
   }


   /**
    *  getSQL for Selecting Classes
    */
   public static String getSearchClassIndexOf(String id){
      StringBuffer reqmsg = new StringBuffer("");
      reqmsg.append("select CS.id, RG.zone_1,CS.name,SB.value as subject,CS.dayofweek,LT.value,CS.start_time , CS.end_time , ");
      reqmsg.append("MB.name_0,MB.name_1,LOC.name as location ,CS.description as description ");
      reqmsg.append("from ClassRoom_Table CS ");
      reqmsg.append("left join Affiliated_Table LT on (LT.code = CS.level and LT.description='LEVEL' and LT.flg='01') ");
      reqmsg.append("left join Affiliated_Table RG on (RG.code = CS.code and RG.description='CLASSROOM' and RG.flg='01') ");
      reqmsg.append("left join Affiliated_Table SB on (SB.code = CS.subject and SB.description='SUBJECT' and SB.flg='01') ");
      reqmsg.append("left join Members_Table MB on (MB.id = CS.teacher and MB.flg='01') ");
      reqmsg.append("left join Location_Table LOC on (LOC.id = CS.location and LOC.flg = '01') ");
      reqmsg.append("where CS.flg='01' and CS.id='");
      reqmsg.append(id);
      reqmsg.append("'");
      return reqmsg.toString();
   }  
   /**
    *  searching max index key for the specific "Tablename"
    */
   public static String getMaxID(String sTableName){ 
      // when the table name is not specified
      if( sTableName == null || sTableName.equals("") )
         return "";
      // otherwise returns SQL for selecting max index(primary key)
      return "select max(id) as maxid ,count(*) as counts from " + sTableName;
   }
   /**
    * Counting records of registration of ,class_id,student_id,date
    * 1) number of ideal student in each class , to avoid duplication of registration
    * 2) maximum studens of selected class       
    * 3) number of records in ClassRoom_EntryTable, which used in calculating Primary Key
    * 4) current number of registered students in a class
    */
   public static String getCountsGroupBy(String class_id,String student_id,String date){
      StringBuffer sb = new StringBuffer("");
       sb.append("select count( distinct CE.id )as counts ,CS.mx_students, max(MX.id) as MX_ID ,count(MX_REG.id) as mx_reg ");
       sb.append(" from ClassRoom_Entry_Table CE left join ClassRoom_Entry_Table MX on MX.ID is NOT NULL");
       sb.append(" left join ClassRoom_Table CS on CS.id = '");
       sb.append(class_id);
       sb.append("' and CS.flg='01' left join ClassRoom_Entry_Table MX_REG on MX_REG.classroom_id='");
       sb.append(class_id);
       sb.append("' and MX_REG.date='");
       sb.append(date);
       sb.append("' and MX_REG.flg='01'  where CE.classroom_id='");
       sb.append( class_id );
       sb.append("' and CE.student_id='");
       sb.append(student_id);
       sb.append("' and CE.date='");
       sb.append(date);
       sb.append("' group by CE.student_id,CE.date"); 
       return sb.toString();
   }

   /**
    *  Selecting Records of registration of student_id , and later than today
    */
   public static String getSearchRegisteredClasses(String student_id){
      GregorianCalendar cal = new GregorianCalendar();
      String date = OMIUtilDate.toString(cal);
      StringBuffer sb = new StringBuffer("select CE.id , CE.classroom_id, CE.date , CS.name,CS.dayofweek,CS.start_time "); 
      sb.append(" from ClassRoom_Entry_Table CE , ClassRoom_Table CS where ");
      sb.append("CS.id=CE.classroom_id and ");
      sb.append("CE.student_id='");
      sb.append(student_id);
      sb.append("' and CE.date >= '");
      sb.append(date);
      sb.append("' and CE.flg='01' order by CE.date,CS.start_time");
      return sb.toString();
   }
   /**
    *  This Method is used in Teacher's Web-Page
    *@param class_id
    *@param date
    */
   public static String getSearchRegisteredStudents(String class_id,String date){
      StringBuffer query = new StringBuffer("");
      query.append("select MT.name_0,MT.name_1 from  ClassRoom_Entry_Table CE "); 
      query.append("left join Members_Table MT on CE.student_id = MT.id ");
      query.append("where classroom_id='");
      query.append(class_id);
      query.append("' and date='");
      query.append(date);
      query.append("'");
      return query.toString();
   }
}
